<!-- Copyright 2016 The Chromium Authors. All rights reserved.
     Use of this source code is governed by a BSD-style license that can be
     found in the LICENSE file. -->

<link rel="import" href="chrome://resources/polymer/v1_0/iron-icon/iron-icon.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-progress/paper-progress.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-styles/color.html">

<link rel="import" href="/components/common_styles.html">
<link rel="import" href="/components/hd_iron_icon.html">
<link rel="import" href="/components/oobe_carousel.html">
<link rel="import" href="/components/oobe_slide.html">
<link rel="import" href="/components/oobe_i18n_behavior.html">
<link rel="import" href="/components/oobe_dialog.html">

<dom-module id="oobe-update-element">
  <template>
    <style include="oobe-dialog-host"></style>
    <link rel="stylesheet" href="oobe_update.css">
    <div hidden="[[betterUpdateScreenFeatureEnabled_]]">
      <checking-downloading-update id="checking-downloading-update"
          aria-label$="[[i18nDynamic(locale, 'updateScreenAccessibleTitle')]]"
          hidden="[[requiresPermissionForCellular]]"
          checking-for-update="[[checkingForUpdate]]"
          cancel-allowed="[[cancelAllowed]]"
          update-completed="[[updateCompleted]]"
          progress-value="[[progressValue]]"
          has-estimate="[[estimatedTimeLeftShown]]"
          estimated-time-left="[[estimatedTimeLeft]]"
          default-progress-message="[[progressMessage]]"
          checking-for-updates-key="checkingForUpdatesMsg"
          cancel-hint-key="[[cancelHint]]"
          downloading-updates-key="installingUpdateDesc">
      </checking-downloading-update>
    </div>
    <oobe-dialog hidden="[[!requiresPermissionForCellular]]" tabindex="0"
        subtitle-key="updateOverCellularPromptMessage"
        aria-live="polite" has-buttons footer-shrinkable
        id="cellular-permission-dialog">
      <hd-iron-icon slot="oobe-icon"
          icon1x="oobe-32:googleg" icon2x="oobe-64:googleg">
      </hd-iron-icon>
      <h1 slot="title">
        [[i18nRecursive(locale, 'updateOverCellularPromptTitle',
                        'productName')]]
      </h1>
      <div slot="footer" class="flex layout vertical center-justified center">
        <img class="update-illustration oobe-illustration"
            srcset="images/1x/updating_1x.svg 1x,
                    images/2x/updating_2x.svg 2x">
      </div>
      <div slot="back-navigation">
        <oobe-back-button id="cellular-permission-back" inverse
            on-click="onBackClicked_"></oobe-back-button>
      </div>
      <div slot="bottom-buttons">
        <oobe-next-button id="cellular-permission-next" inverse
            on-click="onNextClicked_"></oobe-next-button>
      </div>
    </oobe-dialog>
    <div hidden="[[!betterUpdateScreenFeatureEnabled_]]">
      <oobe-dialog footer-shrinkable id="checking-for-updates-dialog"
          hidden="[[!isCheckingForUpdate_(uiState,
                                          requiresPermissionForCellular)]]"
          title-key="checkingForUpdates" aria-live="polite">
        <hd-iron-icon slot="oobe-icon"
            icon1x="oobe-32:googleg" icon2x="oobe-64:googleg">
        </hd-iron-icon>
        <paper-progress slot="progress" id="checking-progress" indeterminate>
        </paper-progress>
        <div slot="footer" class="flex layout vertical center-justified center">
          <img class="update-illustration oobe-illustration"
              srcset="images/1x/updating_1x.svg 1x,
                      images/2x/updating_2x.svg 2x">
        </div>
      </oobe-dialog>
      <oobe-dialog footer-shrinkable id="update-in-progress-dialog"
          hidden="[[!isUpdateInProgress_(uiState,
                                         requiresPermissionForCellular)]]"
          title-key="updateStatusTitle" aria-live="polite">
        <hd-iron-icon slot="oobe-icon"
            icon1x="oobe-32:googleg" icon2x="oobe-64:googleg">
        </hd-iron-icon>
        <div slot="subtitle">
          <span id="better-update-percent">[[updateStatusMessagePercent]]</span>
          <span> | </span>
          <span id="better-update-timeleft">
            [[updateStatusMessageTimeLeft]]
          </span>
        </div>
        <paper-progress slot="progress" id="update-progress"
            value="[[betterUpdateProgressValue]]">
        </paper-progress>
        <div hidden="[[!showLowBatteryWarning]]" id="battery-warning"
            class="slide-view" slot="footer">
          <oobe-slide is-warning>
            <img slot="slide-img" class="update-illustration oobe-illustration"
                srcset="images/1x/update-charge.svg 1x,
                        images/2x/update-charge.svg 2x">
            <div slot="title">
              [[i18nDynamic(locale, 'batteryWarningTitle')]]
            </div>
            <div slot="text">
              [[i18nDynamic(locale, 'batteryWarningText')]]
            </div>
          </oobe-slide>
        </div>
        <div hidden="[[showLowBatteryWarning]]" id="carousel" class="slide-view"
            slot="footer">
          <oobe-carousel slide-duration-in-seconds=3
              auto-transition="[[getAutoTransition_(uiState, autoTransition)]]"
              slide-label="slideLabel"
              selected-button-label="slideSelectedButtonLabel"
              unselected-button-label="slideUnselectedButtonLabel">
            <oobe-slide slot="slides">
              <img slot="slide-img"
                  class="update-illustration oobe-illustration"
                  srcset="images/1x/update-no-waiting.svg 1x,
                          images/2x/update-no-waiting.svg 2x">
              <div slot="title">
                [[i18nDynamic(locale, 'slideUpdateTitle')]]
              </div>
              <div slot="text">[[i18nDynamic(locale, 'slideUpdateText')]]</div>
            </oobe-slide>
            <oobe-slide slot="slides">
              <img slot="slide-img"
                  class="update-illustration oobe-illustration"
                  srcset="images/1x/update-antivirus.svg 1x,
                          images/2x/update-antivirus.svg 2x">
              <div slot="title">
                [[i18nDynamic(locale, 'slideAntivirusTitle')]]
              </div>
              <div slot="text">
                [[i18nDynamic(locale, 'slideAntivirusText')]]
              </div>
            </oobe-slide>
            <oobe-slide slot="slides">
              <img slot="slide-img"
                  class="update-illustration oobe-illustration"
                  srcset="images/1x/update-apps.svg 1x,
                          images/2x/update-apps.svg 2x">
              <div slot="title">[[i18nDynamic(locale, 'slideAppsTitle')]]</div>
              <div slot="text">[[i18nDynamic(locale, 'slideAppsText')]]</div>
            </oobe-slide>
            <oobe-slide slot="slides">
              <img slot="slide-img"
                  class="update-illustration oobe-illustration"
                  srcset="images/1x/google-accounts.svg 1x,
                          images/2x/google-accounts.svg 2x">
              <div slot="title">
                [[i18nDynamic(locale, 'slideAccountTitle')]]
              </div>
              <div slot="text">
                [[i18nDynamic(locale, 'slideAccountText')]]
              </div>
            </oobe-slide>
          </oobe-carousel>
        </div>
      </oobe-dialog>
      <oobe-dialog footer-shrinkable id="restarting-dialog"
          hidden="[[!isRestartInProgress_(uiState,
                                          requiresPermissionForCellular)]]"
          title-key="updateCompeletedRebootingMsg" aria-live="polite">
        <hd-iron-icon slot="oobe-icon"
            icon1x="oobe-32:googleg" icon2x="oobe-64:googleg">
        </hd-iron-icon>
        <paper-progress slot="progress" id="restarting-progress" indeterminate>
        </paper-progress>
      </oobe-dialog>
      <oobe-dialog footer-shrinkable id="better-update-complete-dialog"
          hidden="[[!isManualReboot_(uiState, requiresPermissionForCellular)]]"
          title-key="updateCompeletedMsg" aria-live="polite">
        <hd-iron-icon slot="oobe-icon"
            icon1x="oobe-32:googleg" icon2x="oobe-64:googleg">
        </hd-iron-icon>
      </oobe-dialog>
    </div>
  </template>
</dom-module>
